require 'dm-core'

module Dock
  class DataMapper < Base
    # Checked
    def create(attributes = {})
        model.create(attributes)
    end
    # Checked
    def find(id)
      model.get(id)
    end
    # Checked
    def find!(id)
      model.get!(id)
    end
    # Checked
    def all(options = {})
        conditions, order, limit, offset = extract_conditions!(options)
        opts = { :conditions => conditions, :order => order_clause(order) }
        opts = opts.merge({ :limit => limit }) unless limit.nil?
        opts = opts.merge({ :offset => offset }) unless offset.nil?
        model.all opts
    end
    # Checked
    def first(options = {})
      conditions, order = extract_conditions!(options)
      model.first :conditions => conditions, :order => order_clause(order)
    end
    # Checked
    def id
        # not supported?
    end
    def update(search_key, find_by, update_key, by_value)
      entry = all(search_key find_by)
      entry.attributes = {update_key => by_value}
      entry.save
    end
    # Checked
    def destroy(object)
        object.destroy if valid_object?(object)
    end
    def associations()

    end
    def model_name
      model.class.name
    end
    # Checked
    def column_names
      model.properties.map(&:name)
    end
    # Checked
    def count(options = {})
      all(options).count
    end
    def encoding
      'UTF-8'
    end
    def belongs_to()

    end
    def has_many()

    end
    def scoped?
      true
    end
    def embedded?
      true
    end
    def cyclic?
      false
    end
    def supports_joins?
      false
    end

    def properties()

    end
    protected

      def order_clause(order)
        order.map {|pair| pair.first.send(pair.last)}
      end
    end
  end
