require 'mongoid'

module Dock
  class Mongoid < Base
    # Checked
    def create(attributes = {})
        model.create!(attributes)
    end
    # Checked
    def find(id)
      model.find(wrap_key(id))
    end
    # Checked
    def find!(id)
      model.where(:_id => wrap_key(id)).first
    end
    # Checked
    def all(options = {})
      conditions, order, limit, offset = extract_conditions!(options)
      model.where(conditions_to_fields(conditions)).order_by(order).limit(limit).offset(offset)
    end
    # Checked
    def first(options = {})
      conditions, order = extract_conditions!(options)
      model.limit(1).where(conditions_to_fields(conditions)).order_by(order).first
    end
    # Checked
    def id
      '_id'
    end
    # Checked
    def update(search_key, find_by, update_key, by_value)
      entry = model.where(search_key, find_by)
      entry.update_attributes!(update_key, by_value)
    end
    # Checked
    def destroy(object)
        object.destroy if valid_object?(object)
    end
    def associations()

    end
    # Checked
    def model_name
      model.class.name
    end
    # Checked
    def column_names
      model.fields.keys
    end
    # Checked
    def count(options = {})
      all(options).count
    end
    # Checked
    def encoding
      'UTF-8'
    end
    def belongs_to()

    end
    def has_many()

    end
    # Checked
    def scoped?
      model.scoped
    end
    # Checked
    def embedded?
      model.relations.values.detect { |a| a.macro.to_sym == :embedded_in }
    end
    # Checked
    def cyclic?
      model.cyclic?
    end
    # Checked
    def supports_joins
      false
    end
    def properties()

    end
    protected
      # converts and documents to ids
      def conditions_to_fields(conditions)
        conditions.inject({}) do |fields, (key, value)|
          if value.is_a?(Mongoid::Document) && model.fields.keys.include?("#{key}_id")
            fields.merge("#{key}_id" => value.id)
          elsif key.to_s == 'id'
            fields.merge('_id' => value)
          else
            fields.merge(key => value)
          end
        end
      end
  end
end