require 'nobrainer'

module Dock
  class NoBrainer < Base
    def create(attributes = {})
      model.create!(attributes)
    end
    def find(id)
      model.find(wrap_key(id))
    end
    def find!(id)
      model.find!(wrap_key(id))
    end
    def all(options = {})
      conditions, order, limit, offset = extract_conditions!(options)
      model.where(conditions).order_by(order_to_nql(order)).limit(limit).skip(offset)
    end
    def first(options = {})
      conditions, order = extract_conditions!(options)
      model.where(conditions).order_by(order_to_nql(order)).first
    end
    def id
      'id'
    end
    def update(search_key, find_by, update_key, by_value)
      entry = model.where(search_key => find_by)
      entry.update_attributes!(update_key => by_value)
    end
    def destroy(object)
        object.destroy if valid_object?(object)
    end
    def associations()

    end
    def model_name
      model.class.name
    end
    def column_names
      model.fields.keys
    end
    # Checked
    def count(options = {})
      all(options).count
    end
    def encoding
      'UTF-8'
    end
    def belongs_to()

    end
    def has_many()

    end
    def scoped
      true
    end
    def embedded?
      false
    end
    def cyclic?
      false
    end
    def supports_joins?
      false
    end
    def properties()

    end

    protected
      # NoBrainer does not accept arrays as an `order_by` argument.
      def order_to_nql(order)
        if order.empty?
          nil
        else
          order.to_h
        end
      end
    end
  end
end
