require 'sinatra_activerecord'

module Dock
  class SinatraActiveRecord < Base
     # Checked
    def create(attributes = {})
      model.create!(attributes)
    end
    # Checked
    def find(id)
      model.find(wrap_key(id))
    end
    # Checked
    def find!(id)
      model.where(model.primary_key => wrap_key(id)).first
    end
    # Checked
    def all(options = {})
      construct_relation(model, options)
    end
    # Checked
    def first(options = {})
      construct_relation(model, options).first
    end
    # Checked
    def id
      model.id
    end
    # Checked
    def update(search_key, find_by, update_key, by_value)
      entry = model.find_by(search_key find_by)
      entry.update(update_key by_value)
    end
    # Checked
    def destroy(object)
      object.destroy && true if valid_object?(object)
    end
    def associations()

    end
    # Checked
    def model_name
      model.model_name
    end
    # Checked
    def column_names()
      model.column_names
    end
    # Checked
    def count(options = {})
      all(options).count
    end
    def encoding
      model.client_encoding()
    end
    def belongs_to()

    end
    def has_many()

    end
    # Checked
    def scoped?
      model.all
    end
    # Checked
    def embedded?
      false
    end
    # Checked
    def cyclic?
      false
    end
    # Checked
    def supports_joins?
      true
    end
    def properties()

    end
    protected
        def construct_relation(relation, options)
        conditions, order, limit, offset = extract_conditions!(options)

        relation = relation.where(conditions_to_fields(conditions))
        relation = relation.order(order_clause(order)) if order.any?
        relation = relation.limit(limit) if limit
        relation = relation.offset(offset) if offset

        relation
      end

    # Introspects the model to convert and objects in conditions into foreign key and type fields
      def conditions_to_fields(conditions)
        fields = {}
        conditions.each do |key, value|
          if value.is_a?(::ActiveRecord::Base) && (assoc = model.reflect_on_association(key.to_sym)) && assoc.belongs_to?

          if ::ActiveRecord::VERSION::STRING < "3.1"
            fields[assoc.primary_key_name] = value.send(value.class.primary_key)
            fields[assoc.options[:foreign_type]] = value.class.base_class.name.to_s if assoc.options[:polymorphic]
            else # >= 3.1
              fields[assoc.foreign_key] = value.send(value.class.primary_key)
              fields[assoc.foreign_type] = value.class.base_class.name.to_s if assoc.options[:polymorphic]
            end

          else
            fields[key] = value
          end
        end
        fields
      end

      def order_clause(order)
        order.map {|pair| "#{pair[0]} #{pair[1]}"}.join(",")
        end
    end
  end
end