module Dock
  class Base
    attr_reader :model

    def self.inherited(adapter)
      Dock.adapters << adapter
      super
    end

    def initialize(model)
      @model = model
    end

    def create(attributes = {})
      raise NotSupportedError
    end
    def find(id)
      raise NotSupportedError
    end
    def find!(id)
      raise NotSupportedError
    end
    def all(options = {})
      raise NotSupportedError
    end
    def first(options = {})
      raise NotSupportedError
    end
    def id
      raise NotSupportedError
    end
    def update(search_key, find_by, update_key, by_value)
      raise NotSupportedError
    end
    def destroy(object)
      raise NotSupportedError
    end
    def associations()
      raise NotSupportedError
    end
    def model_name
      raise NotSupportedError
    end
    def column_names
      raise NotSupportedError
    end
    def count(options = {})
      raise NotSupportedError
    end
    def encoding
      raise NotSupportedError
    end
    def belongs_to()
      raise NotSupportedError
    end
    def has_many()
      raise NotSupportedError
    end
    def scoped
      raise NotSupportedError
    end
    def embedded
      raise NotSupportedError
    end
    def cyclic?
      raise NotSupportedError
    end
    def supports_joins?
      raise NotSupportedError
    end
    def properties()
      raise NotSupportedError
    end      
    class NotSupportedError < NotImplementedError
        def to_s
            "method not supported by this Dock adapter"
        end
    end
  end
end