module Pkg
  def Pkg.onload(pkg, lib)
    list = lib.join(' ')
    print list
    begin
      lib.each {|lib| require File.dirname(__FILE__)+'/'+lib}
    rescue Gem::LoadError => e
      raise Gem::LoadError, 'It seems you have an outdated version of one of the following gems: '+list
    rescue LoadError => e
      raise Gem::LoadError, 'Error loading '+pkg+' gems. Make sure that all of the following gems are available: '+list
    end
    return true
  end
end

module Dock
  include Pkg
  adapter = Pkg::onload('Active Record', %w(adapters/active_record))  if defined?(ActiveRecord::Base)
  adapter = Pkg::onload('Cequel', %w(adapters/cequel))  if defined?(Cequel::Record)
  adapter = Pkg::onload('CouchBase', %w(adapters/couchbase))  if defined?(Couchbase::Model)
  adapter = Pkg::onload('CouchDB', %w(adapters/couchdb))  if defined?(Couchrest::Document)
  adapter = Pkg::onload('DataMapper', %w(adapters/datamapper))  if defined?(DataMapper::Resource)
  adapter = Pkg::onload('Mongoid', %w(adapters/mongoid))  if defined?(Mongoid::Document)
  adapter = Pkg::onload('MongoMapper', %w(adapters/mongomapper))  if defined?(MongoMapper::Document)
  adapter = Pkg::onload('NoBrainer', %w(adapters/nobrainer))  if defined?(Nobrainer::Document)
  adapter = Pkg::onload('Sequel', %w(adapters/sequel))  if defined?(Sequel::Model)
  adapter = Pkg::onload('Sinatra ActiveRecord', %w(adapters/sinatra_ar))  if defined?(ActiveRecord::Base) & defined?(Sinatra::ActiveRecord)
  if !adapter  
    raise Gem::LoadError, <<-eos
    No adapters found. You need to require one of the following adapters for Dock to work:
    ActiveRecord         => gem install activerecord and require 'activerecord'
    cequel               => gem install cequel and require 'cequel'
    couchbase            => gem install couchbase and require 'couchbase'
    couchdb              => gem install couchrest and require 'couchrest'
    DataMapper           => gem install dm-core dm-validations dm-aggregates dm-pager and require ''
    mongoid              => gem install mongoid and require 'mongoid'
    MongoMapper          => gem install mongomapper and require 'mongomapper'
    nobrainer            => gem install and require 'nobrainer'
    sequel               => gem install sequel and require 'sequel'
    sinatra_ar           => gem install sinatra-activerecord and require 'sinatra/activerecord'
    eos
  end
end
